<!DOCTYPE html>
<html lang="ko"
	xmlns:th="http://www.thymeleaf.org">
<!--
 *******************************************************************************
 * @source  : GoodsReserveSellForm.html
 * @desc    : 상품예약판매관리
 *============================================================================
 * STYLE24
 * Copyright(C) 2020 TSIT, All rights reserved.
 *============================================================================
 * VER  DATE         AUTHOR      DESCRIPTION
 * ===  ===========  ==========  =============================================
 * 1.0  2020.11.12   eskim   최초 작성
 *******************************************************************************
 -->
	<div id="main">
		<!-- 메인타이틀 영역 -->
		<div class="main-title">
		</div>
		<!-- //메인타이틀 영역 -->
		<!-- 메뉴 설명 -->
		<div class="infoBox menu-desc">
		</div>
		<form id="goodsResSellListForm" name="goodsResSellListForm" action="#" th:action="@{'/goods/reserve/sell/list'}">
		<input type="hidden" id="searchGb" name="searchGb" />
 		<!-- 패널 영역1 -->
		<div class="panelStyle" >
			<div class="panelTitle">
				<h3><i class="fa fa-info-circle"></i>아래 검색조건 중 하나를 꼭 입력해 주세요.</h3>
			</div>
			<div class="panelContent">
				<table class="frmStyle">
					<colgroup>
						<col width="8%"/>
						<col width="25%"/>
						<col width="8%"/>
						<col/>
					</colgroup>
					<tr>
						<th>업체/브랜드</th>
						<td>
							<select name="supplyCompCd" id="supplyCompCd">
								<option value="" th:if="${sessionInfo.roleCd} != 'B000'">[전체]</option>
								<option th:if="${supplyCompList}" th:each="oneData, status : ${supplyCompList}" th:value="${oneData.cd}" th:text="${'[' + oneData.cd + '] ' + oneData.cdNm}"></option>
							</select>
							<select name="brandCd" id="brandCd">
								<option value="">[전체]</option>
							</select>
						</td>
						<th>키워드</th>
						<td>
							<select name="search" id="search">
								<option value="searchGoodsCd">상품코드</option>
								<option value="searchGoodsNm">상품명</option>
								<option value="searchGoodsNum">품번</option>
								<option value="searchSupplyGoodsCd">업체상품코드</option>
							</select>
							<input type="text" class="w50p" name="condition" id="condition" maxlength="50"/>
						</td>
					</tr>
					<tr>
						<th>출고예정일</th>
						<td colspan="3" id="sellTerms"></td>
					</tr>
				</table>
				<ul class="panelBar">
					<li class="center">
						<button type="button" class="btn btn-gray btn-lg" id="btnInit" >초기화</button>
						<button type="button" class="btn btn-info btn-lg" id="btnSearch" >조회</button>
					</li>
				</ul>
			</div>
			<!-- //검색조건 영역 -->
		</div>
		<!-- 패널 영역1 -->
		<div class="panelStyle">
			<!-- 검색결과 영역 -->
			<!-- 상단버튼 영역  -->
			<ul class="panelBar">
				<li class="left">
					<button type="button" class="btn btn-default btn-lg" onclick="cfnDownloadSampleFile('SF003');">상품엑셀조회 양식 다운로드</button>
					<button type="button" class="btn btn-base btn-lg" id="btnGoodsExcelUpLoad">엑셀조회</button>
					<button type="button" class="btn btn-success  btn-lg" id="btnGoodsResSellSave">예약판매등록</button>
					<button type="button" class="btn btn-danger btn-lg" id="btnGoodsResSellDelete">예약판매삭제</button>
				</li>
				<li class="right">
					검색결과 : <strong><span id="gridRowTotalCount">0</span> 건</strong>&nbsp;
					쪽번호 <span id="pgNo">0</span>/ <strong id="endPgNo">0</strong>&nbsp;&nbsp;
					<select id="pageSize" name="pageSize">
						<option value="50" selected="selected">50개씩 보기</option>
						<option value="100">100개씩 보기</option>
						<option value="500">500개씩 보기</option>
						<!-- <option value="1000">1000개씩 보기</option> -->
					</select>
					<input type="hidden" name="pageNo" id="pageNo" value ="1"/>
				</li>
			</ul>
			<!-- //상단버튼 영역  -->
			<div id="gridList" style="width: 100%; height: 500px;" class="ag-theme-balham"></div>
			<ul class="panelBar">
				<!-- Paging -->
				<li class="center">
					<div class="tablePaging" id="goodsListPagination"></div>
				</li>
				<!-- //Paging -->
			</ul>
			<!-- 검색결과 영역 -->
		</div>
		</form>
		<!-- //패널 영역2 -->
	</div>
<script type="text/javascript" src="/ux/plugins/gaga/gaga.paging.js?v=2019072202"></script>
<script th:inline="javascript">
/*<![CDATA[*/
	var sessRoleCd = [[${sessionInfo.roleCd}]];
	var goodsStatList = gagajf.convertToArray([[${goodsStatList}]]);
	var formalGbList = gagajf.convertToArray([[${formalGbList}]]);
	var uploadGoodsUrl = [[${@environment.getProperty('upload.goods.view')}]];
	var columnDefs = [
		{width: 40, minWidth: 40, cellClass: 'text-right', headerCheckboxSelection: true, checkboxSelection: true, filter: false},
		{headerName: 'No', width: 60, cellClass: 'text-center',
			valueGetter: function(params) { return cfnGridNumner('goodsResSellListForm',params.node.rowIndex, 'A');}
		},
		{headerName: "브랜드명", field: "brandEnm", width: 130, cellClass: 'text-center'},
		{headerName: "상품코드", field: "goodsCd", width: 140, cellClass: 'text-center'},
		{headerName: "상품명", field: "goodsNm", width: 250, cellClass: 'text-left'
			,cellRenderer: function(params) {
				return '<a href="javascript:void(0);">' + params.value + '</a>';
			}
		},
		{headerName: "상품상태", field: "goodsStat" , width: 100, cellClass: 'text-center',
			cellEditorParams: { values: gagaAgGrid.extractValues(goodsStatList) },
			valueFormatter: function (params) { return gagaAgGrid.lookupValue(goodsStatList, params.value); },
			valueParser: function (params) { return gagaAgGrid.lookupKey(goodsStatList, params.newValue); }
		},
		{headerName: "출고예정일", field: "delvResDt", width: 150, cellClass: 'text-center',
			cellRenderer: function(params) {
				return !gagajf.isNull(params.value) ? params.value.toDate("YYYYMMDDHHmmss").format("YYYY-MM-DD") : '';
			}
		},
/*		{headerName: "사용여부", field: "useYn", width: 140, cellClass: 'text-center'},*/
		{headerName: "등록일시", field: "regDt", width: 150, cellClass: 'text-center',
			cellRenderer: function(params) {
				return !gagajf.isNull(params.value) ? params.value.toDate("YYYYMMDDHHmmss").format("YYYY-MM-DD HH:mm:ss") : '';
			}
		},
		{headerName: "등록자", field: "regNm", width: 100, cellClass: 'text-center'},
		{headerName: "수정일시", field: "updDt", width: 150, cellClass: 'text-center',
			cellRenderer: function(params) {
				return !gagajf.isNull(params.value) ? params.value.toDate("YYYYMMDDHHmmss").format("YYYY-MM-DD HH:mm:ss") : '';
			}
		},
		{headerName: "수정자", field: "updNm", width: 100, cellClass: 'text-center'}
	];
	
	// Get GridOptions
	var gridOptions = gagaAgGrid.getGridOptions(columnDefs);

	// 중복 선택 가능
	gridOptions.rowSelection = 'multiple';
	gridOptions.suppressRowClickSelection = true;
	//gridOptions.rowHeight = 60; //이미지가 있을경우 높이 지정해야함.

	// Row Click
	gridOptions.onCellClicked = function(event) {
		var goodsCd = event.data.goodsCd;
		if (event.colDef.field == "goodsNm"){
			cfnOpenGoodsDetailPopup('U',goodsCd);
		}else if (event.colDef.field == "goodsCd"){
			
		}
	}

	// 초기화 클릭시
	$('#btnInit').on('click', function() {
		fnInit();
	});
	
	var fnInit = function(){
		$('#goodsResSellListForm')[0].reset();
		$("#goodsResSellListForm input[type=checkbox]").removeClass("checked");
		$("#goodsResSellListForm input[type=checkbox]").parent("label").removeClass("checked");
		$("#goodsResSellListForm input[type=radio][checked]").parent("label").addClass("checked");
	}
	
	// 조회클릭시
	$('#btnSearch').on('click', function() {
		$("#goodsResSellListForm input[name=pageNo]").val('1');
		fnGoodsResSellListSearch('BASIC');
	});

	// 조회
	var fnGoodsResSellListSearch = function(gbn) {
		
		if (typeof(gbn) != 'undefined' &&  gbn == 'EXCEL'){
			$("#goodsResSellListForm input[name=searchGb]").val("EXCEL");
		}else{
			$("#goodsResSellListForm input[name=searchGb]").val("BASIC");
		}
		
		if(!fnConditionCheck()) return;
		
		gagaPaging.init('goodsResSellListForm', fnSearchCallBack, 'goodsListPagination', $('#goodsResSellListForm').find('#pageSize').val());
		gagaPaging.load($("#goodsResSellListForm input[name=pageNo]").val());
	}

	// 조회 (등록 창 닫을 때)
	var fnGoodsResSellRegistListSearch = function(gbn) {

		if (typeof(gbn) != 'undefined' &&  gbn == 'EXCEL'){
			$("#goodsResSellListForm input[name=searchGb]").val("EXCEL");
		}else{
			$("#goodsResSellListForm input[name=searchGb]").val("BASIC");
		}

		gagaPaging.init('goodsResSellListForm', fnSearchCallBack, 'goodsListPagination', $('#goodsResSellListForm').find('#pageSize').val());
		gagaPaging.load($("#goodsResSellListForm input[name=pageNo]").val());
	}

	//검색 조건 확인
	var fnConditionCheck = function(){
		var formId = '#goodsResSellListForm';
		var form = document.goodsResSellListForm;

		if($("#goodsResSellListForm input[name=searchGb]").val() == "EXCEL") return true;
		
		var searchFlag = false;
		var cnt = 0;

		for (i = 0; i < form.elements.length; i++ ) {
			var el = form.elements[i];

			if ($(el).prop("type") == "text" || ($(el).prop("type") == "select-one" && el.name != "search" && el.name != "pageSize")) {
				if (!(el.value == null || el.value == "")) {
					cnt++;
				}
			}
		}
			
		if(cnt > 0) searchFlag = true;

		if(searchFlag == false){
			mcxDialog.alert("검색조건을 입력하세요.");
			return false;
		}
		
		var fromDate = $('#goodsResSellListForm input[name=stDate]').val();
		var toDate = $('#goodsResSellListForm input[name=edDate]').val();
		
		if (!gagajf.isNull(fromDate) || !gagajf.isNull(toDate)) {
			
			if (gagajf.isNull(fromDate) || gagajf.isNull(toDate)) {
				mcxDialog.alertC("등록일 조회시 시작일자와 종료일자를 입력하세요.", {
					sureBtnText: "확인",
					sureBtnClick: function(){
						$('#goodsResSellListForm input[name=stDate]').focus();
					}
				});
				return false;
			}

			if (fromDate > toDate) {
				mcxDialog.alertC("출고예정 시작일자는 종료일자 보다 클 수 없습니다.", {
					sureBtnText: "확인",
					sureBtnClick: function(){
						$('#goodsResSellListForm input[name=stDate]').focus();
					}
				});
				return false;
			} 
		}

		return true;
	}
	
	var fnSearchCallBack = function(result){

		$('#goodsResSellListForm').find('#gridRowTotalCount').html(result.pageing.pageable.totalCount.addComma());
		$('#goodsResSellListForm').find('#pageNo').val(result.pageing.pageable.pageNo.addComma());
		$('#goodsResSellListForm').find('#pgNo').html(result.pageing.pageable.pageNo.addComma());
		$('#goodsResSellListForm').find('#endPgNo').html(result.pageing.pageable.totalPage.addComma());
		gridOptions.api.setRowData(result.goodsResSellList);
		gagaPaging.createPagination(result.pageing.pageable);
	}
	
	//페이징 
	$('#goodsResSellListForm select[name=pageSize]').on('change', function() {
		$("#goodsResSellListForm input[name=pageNo]").val('1');
		fnGoodsResSellListSearch($("#goodsResSellListForm input[name=searchGb]").val());
	});
	
	//업체변경시
	$('#goodsResSellListForm select[name=supplyCompCd]').on('change', function() {
		var actionUrl = '/renderer/supplyCompany/brand/list/' + $(this).val();

		if(sessRoleCd == "B000"){
			actionUrl = '/renderer/brand/AuthBrandlist';
		}
		$("#goodsResSellListForm select[name=brandCd] option:gt(0)").remove();

		cfnCreateCombo(actionUrl, $('#goodsResSellListForm select[name=brandCd]'), "[전체]", "");
	});
	
	//엑셀 상품 조회
	$('#btnGoodsExcelUpLoad').on('click', function() {
		cfnExcelUploadPopup('goodsResSellExcelUpload', 'goodsResSellExcelUpload');
	});
	
	var goodsResSellExcelUpload = function(result){
		var data = {procJob : result.procJob
					,excelFileNm : result.excelFileNm
					};
		var jsonData = JSON.stringify(data);
		gagajf.ajaxJsonSubmit('/goods/search/excelupload/save', jsonData, fngoodsResSellExcelUploadCallBack);
	}
	
	var fngoodsResSellExcelUploadCallBack = function(result){
		fnGoodsResSellListSearch("EXCEL");
	}
	
	//예약등록
	$('#btnGoodsResSellSave').click(function(e) {
		var actionUrl = "/goods/reserve/sell/popup/form";
		cfnOpenModalPopup(actionUrl, 'popupGoodsRsvtList');
	});
	
	//예약삭제
	$('#btnGoodsResSellDelete').click(function(e) {
		//상품선택여부 확인처리 추가
		var selectedData = gridOptions.api.getSelectedRows();

		if (selectedData.length == 0) {
			mcxDialog.alert('선택된 행이 없습니다.');
			return false;
		}
		
		var arrGoodsCd = [];
		var arrGoodsResSellSq = [];
		var chkFlag = false;
		$.each(selectedData, function(idx, item) {
			
			var toDateStr = new Date().format("YYYYMMDDHHmmss");
			if (toDateStr > item.delvResDt){
				chkFlag = true;
				mcxDialog.alertC("출고예정일이 지난 상품예약판매는 삭제할 수 없습니다.", {
					sureBtnText: "확인",
					sureBtnClick: function(){
						$('#goodsResSellForm input[name=applyEdYMD]').focus();
					}
				});
				return false;
			}
		
			arrGoodsCd.push(item.goodsCd);
			arrGoodsResSellSq.push(item.goodsResSellSq);
		});

		if (chkFlag){
			return;
		}
		mcxDialog.confirm('삭제하시겠습니까?', {
			cancelBtnText: "취소",
			sureBtnText: "확인",
			sureBtnClick: function(){
				var data = {arrGoodsCd : arrGoodsCd
						,arrGoodsResSellSq : arrGoodsResSellSq
			};
			
			var jsonData = JSON.stringify(data);
			gagajf.ajaxJsonSubmit('/goods/reserve/sell/delete', jsonData, fnGoodsResSellDeleteCallBack);
			}
		});
		
	});
	
	var fnGoodsResSellDeleteCallBack = function(){
		fnGoodsResSellRegistListSearch($("#goodsResSellListForm input[name=searchGb]").val());
	}
	
	$(document).ready(function() {

		cfnCreateCalendar('#sellTerms', 'applyStdt', 'applyEddt', true, '예약일', 'X');
		var chkBeforSkipFlag = '&nbsp;&nbsp;<label class="chkBox"><input type="checkbox" name="beforSkipFlag" value="Y" >이전데이터 제외</label>';
		$("#goodsResSellListForm").find('#sellTerms').append(chkBeforSkipFlag);
		
		// Create a agGrid
		gagaAgGrid.createGrid('gridList', gridOptions);

	});

/*]]>*/
</script>
 	
</html>